/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ex;


import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Properties;

/**
 *
 * @author jarek
 */
public class ClientInfoDemo {

    public static void main(String[] args) {
        Connection con = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;
 
        try {
            EnvInfoSingleton env = EnvInfoSingleton.INSTANCE;
            con = DriverManager.getConnection(env.getDbURL() + env.getServerName() + ";trace=" + env.getTrace(), env.getDbUser(),
                    env.getDbPassword());
        } catch (SQLException e) {
            e.printStackTrace();
        }
        try {
            DatabaseMetaData dbmd = con.getMetaData();
            ResultSet cipRS = dbmd.getClientInfoProperties();
            while (cipRS.next()) {
                System.out.println(cipRS.getString("NAME") + " " +
                        cipRS.getString("MAX_LEN") + " " 
                        + cipRS.getString("DEFAULT_VALUE").trim() +
                        " " + cipRS.getString("DESCRIPTION").trim());
            }
            Properties clientInfoProps = new Properties();
            clientInfoProps.setProperty("ApplicationName", "JDBCTester.ClientInfoDemo");
            clientInfoProps.setProperty("ClientUser", "Jarek Miszczyk");
            clientInfoProps.setProperty("ClientHostname", "dingo.rochestermn.ibm.com");
            clientInfoProps.setProperty("ClientAccounting", "025-B105");
            clientInfoProps.setProperty("ClientProgramID", "2008.07.11-ClientInfoDemo.java");
            con.setClientInfo(clientInfoProps);
            String query = "SELECT " + "trim(CURRENT CLIENT_APPLNAME) AS \"ApplicationName\"," 
                    + "trim(CURRENT CLIENT_USERID) AS \"ClientUser\"," 
                    + "trim(CURRENT CLIENT_WRKSTNNAME) AS \"ClientHostName\"," 
                    + "trim(CURRENT CLIENT_ACCTNG) AS \"ClientAccounting\"," 
                    + "trim(CURRENT CLIENT_PROGRAMID) AS \"ClientProgramID\"" 
                    + " FROM sysibm.sysdummy1";
            pstmt = con.prepareStatement(query);
            rs = pstmt.executeQuery();
            if (rs.next()) {
                System.out.println("ApplicationName  : " + rs.getString(1).trim());
                System.out.println("ClientUser       : " + rs.getString(2).trim());
                System.out.println("ClientHostname   : " + rs.getString(3).trim());
                System.out.println("ClientAccounting : " + rs.getString(4).trim());
                System.out.println("ClientProgramID  : " + rs.getString(5).trim());
            }


        } catch (Exception se) {
            se.printStackTrace();
        } finally {
            try {
                rs.close();
                pstmt.close();
                con.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }
}
